//
// main.cpp
//

#define STRICT
#include <windows.h>
#include "resource.h"
#include "mclbtest.h"


LPSTR szCaption = "ODLB Independent Demo -- Your Demo, My QA";
LPSTR szAppName = "MAIN";

extern "C" {
LRESULT CALLBACK EXPORT WndProc(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK EXPORT DlgProc(HWND,UINT,WPARAM,LPARAM);
int     CALLBACK         WinMain(HINSTANCE, HINSTANCE, LPSTR, int);
}

/////////////////////////////////////////////////////////////////////////
// The WinMain Procedure
/////////////////////////////////////////////////////////////////////////

int CALLBACK WinMain (HINSTANCE hInst, HINSTANCE hPrevInst,
	LPSTR lpszCmdLine, int nCmdShow)
{
	HWND     hwnd;
	MSG      msg;
	WNDCLASS wndclass;

	if (!hPrevInst) {
		wndclass.style         = 0;
		wndclass.lpfnWndProc   = WndProc;
		wndclass.cbClsExtra    = 0;
		wndclass.cbWndExtra    = 0;
		wndclass.hInstance     = hInst;
		wndclass.hCursor       = LoadCursor(NULL,IDC_ARROW);
		wndclass.hIcon         = NULL;
		wndclass.hbrBackground = NULL;
		wndclass.lpszMenuName  = szAppName;
		wndclass.lpszClassName = szAppName;
		RegisterClass(&wndclass);
	}
	hwnd = CreateWindow(szAppName, szCaption, WS_OVERLAPPEDWINDOW,
				CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
				NULL, NULL, hInst, NULL);
	ShowWindow(hwnd,nCmdShow);
	UpdateWindow(hwnd);
	while (GetMessage(&msg,NULL,0,0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;

}	// end of ::WinMain().

/////////////////////////////////////////////////////////////////////////
// The Window Procedure 
/////////////////////////////////////////////////////////////////////////

	HMCDemoListbox  theLB;	// for window demo
	HMCDemoListbox* ptrLB;

LRESULT CALLBACK EXPORT WndProc (HWND hWnd, UINT msg, WPARAM wP, LPARAM lP)
{
	RECT rc;
	FARPROC fp;
	
	switch (msg) {
	case WM_CREATE:
		// We need to set up and initialize the ODLB --
		rc.left = rc.top = 0; rc.right = rc.bottom = 5;
		theLB.Create(HLBS_STANDARD, rc, hWnd);
		theLB.Setup(TRUE);
		theLB.FillMyBox();
		return 0;
	
	case WM_SIZE:
		// Resize the ODLB --
		rc.left = rc.top = 0;
		rc.right = LOWORD(lP); rc.bottom = HIWORD(lP);
		theLB.SetCaptionDistance(0);
		theLB.MoveCaptionBox(&rc);
		return 0;

	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;

	case WM_COMMAND:
		switch (LOWORD(wP)) {
		case IDM_DLGTEST:
			ptrLB = new HMCDemoListbox;
			fp = MakeProcInstance((FARPROC)DlgProc,GETINSTANCE(hWnd));
			DialogBox(GETINSTANCE(hWnd),MAKEINTRESOURCE(IDD_DLGTEST),hWnd,(DLGPROC)fp);
			FreeProcInstance(fp);
			delete ptrLB;
			return 0;
		case IDM_EXIT:
			SendMessage(hWnd,WM_CLOSE,0,0);
			return 0;
		}
		break;

	case WM_COMPAREITEM:
	case WM_DELETEITEM:
	case WM_DRAWITEM:
	case WM_MEASUREITEM:	return theLB.MsgProc(msg,wP,lP);

	}

	return DefWindowProc(hWnd,msg,wP,lP);

}	// end of ::WndProc().

/////////////////////////////////////////////////////////////////////////
// The Dialog Box Procedure
/////////////////////////////////////////////////////////////////////////

BOOL CALLBACK EXPORT DlgProc (HWND hWnd, UINT msg, WPARAM wP, LPARAM lP)
{
	RECT rect;
	POINT pt;
	
	switch (msg) {
	
	case WM_INITDIALOG:
		ptrLB->SubclassDlgItem(hWnd,IDC_LIST);
		ptrLB->Setup(FALSE);
		ptrLB->Caption()->colorFrame = RGB(255,0,0);
		::GetWindowRect(ptrLB->HWnd(),&rect);
		pt.x = rect.left, pt.y = rect.top;
		::ScreenToClient(hWnd,&pt);
		rect.left = pt.x, rect.top = pt.y;
		pt.x = rect.right, pt.y = rect.bottom;
		::ScreenToClient(hWnd,&pt);
		rect.right = pt.x, rect.bottom = pt.y;
		ptrLB->MoveCaptionBox(&rect);
		ptrLB->FillMyBox();
		return TRUE;
		
	case WM_COMMAND:
		if (LOWORD(wP)==IDOK) {
			EndDialog(hWnd,IDOK);
			return TRUE;	
		}
		break;

	case WM_COMPAREITEM:
	case WM_DELETEITEM:
	case WM_DRAWITEM:
	case WM_MEASUREITEM:	return ptrLB->MsgProc(msg,wP,lP);
		
	}

	return FALSE;

}	// end of ::DlgProc().
