// genlbdlg.cpp : implementation file
//

#include "stdafx.h"
#include "odlbdemo.h"
#include "genlbdlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
//
// class HMyUniqueItem : public HListItem -- item class that demonstrates 
// general use of ODLB (requires no box class customization for simplicity.)
//

class HMyUniqueItem : public HListItem
{
public:
	HMyUniqueItem(HBaseBox* box, BOOL enable=TRUE);
	virtual void SetString (const char*, LONG extra=-1L) {}
	virtual const char* GetString (LONG extra=-1L) const;
	void Recalc ();
protected:
	virtual void draw (const DRAWITEMSTRUCT&);
	virtual int compare (HListItem* rhs) const { return 0; }
	// run-time info is not needed in this case.
private:
	int value;
};

#include <stdlib.h>
#include <stdio.h>

HMyUniqueItem::HMyUniqueItem(HBaseBox* box, BOOL enable) 
	: HListItem(box,enable) 
{
	value=50;
}

void HMyUniqueItem::Recalc ()
{
	int x = rand();
	if (x>RAND_MAX/2) value += 5;
	else value -= 5;
	if (value>100) value = 100;
	else if (value<0) value = 0;
}

const char* HMyUniqueItem::GetString (LONG) const
{
	static char buf[10];
	sprintf(buf,"%d%%", value);
	return buf;
}

void HMyUniqueItem::draw (const DRAWITEMSTRUCT& dis)
{
	RECT rc = dis.rcItem;
	// Draw the background --
	theBox->DrawTextWithPalette (NULL,dis,rc,"",0,RIGHT);
	// Draw the text --
	rc.right = 40;
	theBox->DrawTextWithPalette(NULL, dis, rc, GetString(), 0, RIGHT);
	// Draw the indicator --
	rc.left = rc.right + 5;
	long x = dis.rcItem.right - rc.left;
	x *= value;
	x /= 100;
	rc.right = (int)x + rc.left;
	

	HBRUSH hBrush = (HBRUSH)::SelectObject(dis.hDC,CreateSolidBrush(RGB(0,255,0)));
	::Rectangle(dis.hDC,rc.left,rc.top,rc.right,rc.bottom);
	::DeleteObject (::SelectObject(dis.hDC,hBrush));

}	// end of HMyUniqueItem::draw().


/////////////////////////////////////////////////////////////////////////////
// CGenLBTestDlg dialog


CGenLBTestDlg::CGenLBTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGenLBTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGenLBTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

BEGIN_MESSAGE_MAP(CGenLBTestDlg, CDialog)
	//{{AFX_MSG_MAP(CGenLBTestDlg)
	ON_WM_TIMER()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CGenLBTestDlg message handlers

BOOL CGenLBTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	SetWindowText("Generic ODLB Demo/QA");
	srand(0);
	
	// Initialize the listbox --
	m_List.SubclassDlgItem(IDC_LIST,this);
	m_List.palette[0].sel_bk = m_List.palette[0].norm_bk;
	
	for (int i=0; i<25; i++)
		m_List.AddItem(new HMyUniqueItem(&m_List));
	
	// Set up the timer --
	timerID = SetTimer(1,2000,NULL);
	SetDlgItemText(IDC_COMMENT,"Every 2 seconds, all items increment/decrement by 5% randomly.");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGenLBTestDlg::OnTimer(UINT nIDEvent)
{
	for (int i=m_List.GetItemCount(); i>=0; i--)
		((HMyUniqueItem*)m_List.GetItem(i))->Recalc();
	m_List.Redraw();
	CDialog::OnTimer(nIDEvent);
}

void CGenLBTestDlg::OnClose()
{
	KillTimer(timerID);
	CDialog::OnClose();
}
