// hierdlg.cpp : implementation file
//

#include "stdafx.h"
#include "odlbdemo.h"
#include "hierdlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CMyHierLB

// Bitmap index --
#define BMP_ROOTCLOSED      0
#define BMP_ROOTOPENED     14
#define BMP_ROOTNOCHILD     1
#define BMP_C_COMPCLOSED    2
#define BMP_C_COMPOPENED    3
#define BMP_C_COMPNOCHILD   4
#define BMP_C_LOVECLOSED    5
#define BMP_C_LOVEOPENED    6
#define BMP_C_LOVENOCHILD   7
#define BMP_C_MISCCLOSED    8
#define BMP_C_MISCOPENED    9
#define BMP_C_MISCNOCHILD  10
#define BMP_B_COMP         11
#define BMP_B_LOVE         12
#define BMP_B_MISC         13

UINT bmIds[] = { IDB_BITMAP1,IDB_BITMAP2,IDB_BITMAP3,IDB_BITMAP4,IDB_BITMAP5,
	IDB_BITMAP6,IDB_BITMAP7,IDB_BITMAP8,IDB_BITMAP9,IDB_BITMAP10,IDB_BITMAP11,
	IDB_BITMAP12,IDB_BITMAP13,IDB_BITMAP14,IDB_BITMAP15 };

#define PAL_ROOT     0
#define PAL_CATEGORY 1
#define PAL_BOOK     2
	
CMyHierLB::CMyHierLB () 
	: HHierBitmapHandler(this,AfxGetApp()->m_hInstance,sizeof(bmIds)/sizeof(bmIds[0]),bmIds)
{
	root = computerCategory = loveCategory = miscCategory = NULL;
	frmColor = RGB(255,0,0);
	palette[0].norm_bk = RGB(191,191,191);
	palette[0].norm_text = RGB(255,0,0);
	palette[0].font = ::CreateFont(20,9,0,0,FW_BOLD,0,0,0,0,OUT_TT_PRECIS,
				CLIP_TT_ALWAYS,PROOF_QUALITY,VARIABLE_PITCH,"New Times Romans");
}


CMyHierLB::~CMyHierLB ()
{
	if (root) root->DestroyAll();
	::DeleteObject((HGDIOBJ)palette[0].font);
}

void CMyHierLB::AddBook (short type, const char* title)
{
	AddCategory(type);
	
	switch (type) {
	case 1:
		computerCategory->AddChildSorted(new 
			HHierItem(this,title, TRUE, TRUE, PAL_BOOK, BMP_B_COMP));
		break;
	case 2:
		loveCategory->AddChildSorted(new 
			HHierItem(this,title, TRUE, TRUE, PAL_BOOK, BMP_B_LOVE));
		break;
	default:
		miscCategory->AddChildSorted(new 
			HHierItem(this,title, TRUE, TRUE, PAL_BOOK, BMP_B_MISC));
		break;
	}
}

void CMyHierLB::AddCategory (short type)
{
	if (ExistCategory(type)) return;
	switch (type) {
	case 0:
		root = new HHierItem(this,"     My Books",FALSE,TRUE, 
				PAL_ROOT, BMP_ROOTNOCHILD, BMP_ROOTCLOSED, BMP_ROOTOPENED);
		root->LoadTreeToListBox(this);
		break;
	case 1:
		AddCategory(0);
		root->AddChildSorted(computerCategory = 
			new HHierItem(this,"Computer Books",FALSE,TRUE, PAL_CATEGORY, 
				BMP_C_COMPNOCHILD, BMP_C_COMPCLOSED, BMP_C_COMPOPENED));
		break;
	case 2:
		AddCategory(0);
		root->AddChildSorted(loveCategory = 
			new HHierItem(this,"Love Books",FALSE,TRUE, PAL_CATEGORY, 
				BMP_C_LOVENOCHILD, BMP_C_LOVECLOSED, BMP_C_LOVEOPENED));
		break;
	default:
		AddCategory(0);
		root->AddChildSorted(miscCategory = 
			new HHierItem(this,"Miscellaneous Books",FALSE,TRUE, PAL_CATEGORY, 
				BMP_C_MISCNOCHILD, BMP_C_MISCCLOSED, BMP_C_MISCOPENED));
	}
}

BOOL CMyHierLB::ExistCategory (short type) const
{
	switch (type) {
	case 0:		return root!=NULL;
	case 1:		return computerCategory!=NULL;
	case 2:		return loveCategory!=NULL;
	default:	return miscCategory!=NULL;
	}
}

void CMyHierLB::DeleteCurrent ()
{
	HHierItem* item = (HHierItem*)GetCurrentItem();
	if (!item) return;
	item->DetachSubtree(TRUE);
	if (item==root) 
		root = computerCategory = loveCategory = miscCategory = NULL;
	else if (item==computerCategory) 
		computerCategory = NULL;
	else if (item==loveCategory) 
		loveCategory = NULL;
	else if (item==miscCategory) 
		miscCategory = NULL;
	item->DestroyAll(FALSE);
	
}   // end of CMyHierLB::DeleteCurrent().



/////////////////////////////////////////////////////////////////////////////
// CHierLBTestDlg dialog


CHierLBTestDlg::CHierLBTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHierLBTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHierLBTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


BEGIN_MESSAGE_MAP(CHierLBTestDlg, CDialog)
	//{{AFX_MSG_MAP(CHierLBTestDlg)
	ON_BN_CLICKED(IDC_ADDCOMPUTER, OnAddcomputer)
	ON_BN_CLICKED(IDC_ADDLOVE, OnAddlove)
	ON_BN_CLICKED(IDC_ADDMISC, OnAddmisc)
	ON_BN_CLICKED(IDC_COMPUTERBOOKS, OnComputerbooks)
	ON_BN_CLICKED(IDC_LOVEBOOKS, OnLovebooks)
	ON_BN_CLICKED(IDC_MISCBOOKS, OnMiscbooks)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	ON_LBN_DBLCLK(IDC_LIST, OnDblclkList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CHierLBTestDlg message handlers

BOOL CHierLBTestDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_List.SubclassDlgItem(IDC_LIST,this);
	m_List.AddCategory(0);
	return TRUE;
}

void CHierLBTestDlg::OnDblclkList() 
{
	HHierItem* hhi = (HHierItem*)m_List.GetCurrentItem();
	if (!hhi) return;
	hhi->DoOpenClose();
}

void CHierLBTestDlg::OnAddcomputer() 
{
	CString str;
	GetDlgItem(IDC_BOOKNAME)->GetWindowText(str);
	m_List.AddBook(1,(const char*)str);
}

void CHierLBTestDlg::OnAddlove() 
{
	CString str;
	GetDlgItem(IDC_BOOKNAME)->GetWindowText(str);
	m_List.AddBook(2,(const char*)str);
}

void CHierLBTestDlg::OnAddmisc() 
{
	CString str;
	GetDlgItem(IDC_BOOKNAME)->GetWindowText(str);
	m_List.AddBook(3,(const char*)str);
}

void CHierLBTestDlg::OnComputerbooks() 
{
	m_List.AddCategory(1);
}

void CHierLBTestDlg::OnLovebooks() 
{
	m_List.AddCategory(2);
}

void CHierLBTestDlg::OnMiscbooks() 
{
	m_List.AddCategory(3);
}

void CHierLBTestDlg::OnDelete() 
{
	m_List.DeleteCurrent();
}
