// mclbtest.cpp

#include "stdafx.h"
#include "mclbtest.h"

/////////////////////////////////////////////////////////////////////////////
// CMyMCLB Implementation

BEGIN_MESSAGE_MAP(CMyMCLB,CHMCListBox)
	ON_MESSAGE(MCLB_CAPTIONLUP, CaptionLUp)
	ON_MESSAGE(MCLB_CAPTIONRUP, CaptionRUp)
END_MESSAGE_MAP()


void CMyMCLB::Setup (BOOL relative)
{
	bkColor  = RGB(0,0,255);
	frmColor = RGB(255,0,0);
    
    palette[0].norm_text = RGB (255,255,255);
	palette[0].gray_text = RGB (127,127,127);
	palette[0].sel_text  = RGB (  0,255,255);
	palette[0].norm_bk   = RGB (  0,  0,  0);
	palette[0].gray_bk   = RGB (255,255,255);
	palette[0].sel_bk    = RGB (127,127,255);
    
    palette[1].norm_text = palette[0].sel_text;		// emulating
	palette[1].gray_text = palette[0].gray_text;	// column
	palette[1].sel_text  = RGB (127,  0,  0);		// selection
	palette[1].norm_bk   = palette[0].sel_bk;		// and the
	palette[1].gray_bk   = palette[0].gray_bk;		// crossed item
	palette[1].sel_bk    = RGB (127,255,255);		// is more highted

	UseHorzGridline();
	WORD dim_percent[9] = { 40, 30, 3, 18, 40, 24, 8, 12, 17 };
	HColAttr attrs[9];
	attrs[0] = HColAttr(LEFT,   VCENTER, 0, 0, 1);
	attrs[1] = HColAttr(RIGHT,  VCENTER, 0, 0, 0);
	attrs[2] = HColAttr(LEFT,   VCENTER, 0, 0, 0);
	attrs[3] = HColAttr(LEFT,   VCENTER, 0, 0, 1);
	attrs[4] = HColAttr(LEFT,   VCENTER, 0, 0, 1);
	attrs[5] = HColAttr(CENTER, VCENTER, 0, 0, 1);
	attrs[6] = HColAttr(CENTER, VCENTER, 0, 0, 1);
	attrs[7] = HColAttr(CENTER, VCENTER, 0, 0, 1);
	attrs[8] = HColAttr(CENTER, VCENTER, 0, 0, 1);

	SetTabsPercent(relative, sizeof(dim_percent)/sizeof(dim_percent[0]),
			dim_percent, attrs);

	WORD caption_align[9] = { 
		 CENTER		// SALUTATION
		,MERGE 		// FIRST NAME &
		,MERGE      // SPACE & 
		,CENTER		// LAST NAME
		,CENTER		// ADDRESS
		,CENTER		// CITY
		,LEFT		// STATE
		,LEFT		// ZIPCODE
		,CENTER		// CREATE DATE
	};
	SetCaption(sizeof(caption_align)/sizeof(caption_align[0]), caption_align);
	
	// Set the captions --
	Caption()->colorFrame = RGB(255,255,0);
	Caption()->colorText = RGB(0,0,255);
	Caption()->colorBkgnd = RGB(255,127,127);
	Caption()->hasFrame = TRUE;
	Caption()->ms.SetString(0,"Salute");
	Caption()->ms.SetString(3,"Name");
	Caption()->ms.SetString(4,"Address");
	Caption()->ms.SetString(5,"City");
	Caption()->ms.SetString(6,"State");
	Caption()->ms.SetString(7,"Zipcode");
	Caption()->ms.SetString(8,"BirthDay");
	
	CreateCaption (ItemHeight()+6);
	
}	// end of HMyMCLB::Setup().


void CMyMCLB::FillMyBox ()
{
	HParadoxTextRecord ptr("emplist.dat");
	for (;;) {
		HMyItem* mci = new HMyItem(this);
    	if (mci->GetRec(ptr)) AddItem(mci);
    	else { delete mci; break; }
    }
}

//
// Mouse Left Button Up causes that column to be "selected":
//
LRESULT CMyMCLB::CaptionLUp (WPARAM,LPARAM L)
{
	// Column drawn as selected --
	if (L==selectedColumn) return 0L;

	// reset the last selected column --
	if (selectedColumn==3) {
		GetColItem(1).attr.palette = 0;
		GetColItem(2).attr.palette = 0;
	}
	GetColItem(selectedColumn).attr.palette = 0;
	
	// set the current selected column --
	switch (selectedColumn = L) {
	case 3:	// name
		GetColItem(1).attr.palette = 1;
		GetColItem(2).attr.palette = 1;
	case 0:	case 4:	case 5:	case 6:	case 7:	case 8:
		GetColItem(selectedColumn).attr.palette = 1;
		break;
	default: return 0L;
	}
	
	// re-draw --
	Redraw();
	return 0L;
}

//
// Mouse Left Button Double Click causes that column to be key column:
//
LRESULT CMyMCLB::CaptionRUp (WPARAM,LPARAM L)
{
	// Then column L becomes key column 
	// (in case of name, key columns are: Last Name/First Name)
	if (L!=KeyCol[0] && L>=0 && L<9) {	
		KeyCol[0] = L;
		KeyCol[1] = (L==3) ? 1 : -1;  // this 1 is the column # of First Name.
		Refresh();	// rehash.
	}
	return 0L;
}


/////////////////////////////////////////////////////////////////////////////
// HMyItem Implementation

LPCSTR HMyItem::GetString (LONG col) const
{
	switch (col) {
	case 0:  return (const char*)rec[10];
	case 1:  return (const char*)rec[ 2];
	case 3:  return (const char*)rec[ 1];
	case 4:  return (const char*)rec[ 4];
	case 5:  return (const char*)rec[ 6];
	case 6:  return (const char*)rec[ 7];
	case 7:  return (const char*)rec[ 8];
	case 8:  return (const char*)rec[13];
	default: return (LPCSTR)"";
	}
}

short HMyItem::GetRec (HParadoxTextRecord& ptr)
{
   	short retVal = ptr.GetNextRec(2048,rec.Fields(), rec.NumFields());
   	Enable (rec[12].GetShort());
   	return retVal;
}
