// txtlbdlg.cpp : implementation file
//

#include "stdafx.h"
#include "odlbdemo.h"
#include "txtlbdlg.h"
#include "odlb.h"
#include <stdlib.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTextLBTestDlg dialog


CTextLBTestDlg::CTextLBTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTextLBTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTextLBTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

BEGIN_MESSAGE_MAP(CTextLBTestDlg, CDialog)
	//{{AFX_MSG_MAP(CTextLBTestDlg)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	ON_BN_CLICKED(IDC_GRIDLINE, OnGridline)
	ON_BN_CLICKED(IDC_DELETEDISABLED, OnDeletedisabled)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CTextLBTestDlg message handlers

BOOL CTextLBTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Initialize the listbox --
	m_List.SubclassDlgItem(IDC_LIST,this);
	m_List.data = 1;	// initially have gridlines.
    
	m_List.palette[0].norm_text = RGB (255,  0,  0);
	m_List.palette[1].norm_text = RGB (  0,255,  0);
	m_List.palette[2].norm_text = RGB (  0,  0,255);
	m_List.palette[3].norm_text = RGB (  0,  0,  0);
	
	  m_List.palette[0].font
	= m_List.palette[1].font 
	= m_List.palette[2].font
	= m_List.palette[3].font = (HFONT)::GetStockObject(OEM_FIXED_FONT);

	// Initialize other things --
	SendDlgItemMessage(IDC_GRIDLINE,BM_SETCHECK,1);
	SetDlgItemText(IDC_EDITOFFSET,"0");
	SendDlgItemMessage(IDC_ENABLED,BM_SETCHECK,1);
	SendDlgItemMessage(IDC_PALETTE,CB_ADDSTRING,0,(LPARAM)"0");
	SendDlgItemMessage(IDC_PALETTE,CB_ADDSTRING,0,(LPARAM)"1");
	SendDlgItemMessage(IDC_PALETTE,CB_ADDSTRING,0,(LPARAM)"2");
	SendDlgItemMessage(IDC_PALETTE,CB_ADDSTRING,0,(LPARAM)"3");
	SendDlgItemMessage(IDC_PALETTE,CB_SETCURSEL,0);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTextLBTestDlg::OnAdd()
{
	CString text;
	GetDlgItem(IDC_EDIT)->GetWindowText(text);
	CString offset;
	GetDlgItem(IDC_EDITOFFSET)->GetWindowText(offset);
	int idx = m_List.AddItem(new HTextItem(&m_List, (LPCSTR)text,
				SendDlgItemMessage(IDC_ENABLED,BM_GETCHECK),
				LEFT,
				SendDlgItemMessage(IDC_PALETTE,CB_GETCURSEL),
				atoi((LPCSTR)offset) ) );
	m_List.MoveTo(idx);
}

void CTextLBTestDlg::OnDelete()
{
	m_List.DeleteSelected();
}

void CTextLBTestDlg::OnGridline()
{
	m_List.data = SendDlgItemMessage(IDC_GRIDLINE,BM_GETCHECK) ? 1 : 0;
	m_List.Redraw();
}

void CTextLBTestDlg::OnDeletedisabled()
{
	m_List.DeleteDisabled();
}
