//	OWNER-DRAW LISTBOX/COMBOBOX CLASS LIBRARY
// COPYRIGHT 1995 JAMES J. HUANG
// ALL RIGHTS RESERVED
//
// WARRANTY: THIS CODE IS PROVIDED AS-IS. THE AUTHOR AND DISTRIBUTORS ARE
//           NOT LIABLE TO ANY DAMAGES THAT MAY INCUR OUT OF USING THIS 
//           CLASS LIBRARY.
//

#ifndef __MSTRING_H
#define __MSTRING_H

// FILE:     MSTRING.H
//
//	CONTENTS: class HMultiString
//

#include "hstring.h"

class HMultiString 
{
public:
	HMultiString (int num_strings=1);
	HMultiString (const HMultiString&);
	~HMultiString ();

	void SetSize (int num_strings);
	LPCSTR GetString (int col) const;
	int  GetStringLen (int col) const;							// inline
	int  NumStrings () const;									// inline
	void SetString (int col, LPCSTR string);
	int  CompareString (int col, LPCSTR string) const;			// inline
	int  CompareStringNoCase (int col, LPCSTR string) const;	// inline
	int  Compare (int col, HMultiString &sec_ms) const;			// inline
	int  CompareNoCase (int col, HMultiString &sec_ms) const;	// inline
	HMultiString& operator= (const HMultiString&);
		
protected:
	HString*	ar;
	int			numStrings;
	
};  // HMultiString.


// inline functions --

inline int  HMultiString::GetStringLen (int col) const 
	{ return (col<numStrings) ? ar[col].GetLength() : 0; }
inline int HMultiString::NumStrings () const
	{ return numStrings; }
inline int  HMultiString::CompareString (int col, LPCSTR string) const 
	{ return (col>=numStrings) ? 0 : ar[col].Compare(string); }
inline int HMultiString::Compare (int col, HMultiString &sec_ms) const 
	{ return CompareString (col,sec_ms.GetString(col)); }
inline int HMultiString::CompareNoCase (int col, HMultiString &sec_ms) const 
	{ return CompareStringNoCase (col,sec_ms.GetString(col)); }
inline int  HMultiString::CompareStringNoCase (int col, LPCSTR string) const 
	{ return (col>=numStrings) ? 0 : ar[col].CompareNoCase(string); }

#endif
